;
;   application : Thorns Crown
;   compiler    : fasm
;   system      : MenuetOS
;   author      : macgub
;   email       : macgub3@wp.pl
;   line drawing - own procedure, maybye a bit slow but my own ;)
timeout equ 1
xo equ 250       ; axle coordinates
zo equ 150
Wmaxx equ 630    ; window size
Wmaxy equ 450
LinesCount equ 72
X_SIZE equ 620   ; screen buffer size
Y_SIZE equ 400
use32

               org    0x0

               db     'MENUET01'              ; 8 byte id
               dd     0x01                    ; header version
               dd     START                   ; start of code
               dd     I_END                   ; size of image
               dd     0x150000                ; memory for app
               dd     0x7fff0                 ; esp
               dd     0x0 , 0x0               ; I_Param , I_Icon

START:                          ; start of execution

     call draw_window

still:

    mov  eax,23                 ; check for event
    mov  ebx,timeout
    int  0x40
;     mov eax,11
;     int 0x40

    cmp  eax,1                  ; redraw request ?
    je   red
    cmp  eax,2                  ; key in buffer ?
    je   key
    cmp  eax,3                  ; button in buffer ?
    je   button

    jmp  noclose

  red:                          ; redraw
    call draw_window
    jmp  noclose

  key:                          ; key
    mov  eax,2                  ; just read it and ignore
    int  0x40
    jmp  noclose

  button:                       ; button
    mov  eax,17                 ; get id
    int  0x40

    cmp  ah,1                   ; button id=1 ?
    jne  noclose

    mov  eax,-1                 ; close this program
    int  0x40
  noclose:
    call CalculateAngle
    call CopyLines
    call Rotate
    call SetSQ
    call TranslateLines

    mov edi,screen_buffer   ;clrscr
    mov ecx,X_SIZE*Y_SIZE*3/4
    xor eax,eax
    cld
    rep stosd

    call DrawLines

    mov ebx,screen_buffer   ;draw buffer
    mov ecx,X_SIZE shl 16 + Y_SIZE
    mov edx,5 shl 16 + 20
    mov eax,7
    int 0x40

    jmp  still

SetSQ:
  finit
  fld [onesq]
  fimul [sqcounter]
  fstp [sq]
  cmp [sqcounter],707
  jne setsq3
  mov [sqdir],0
  jmp setsq4
 setsq3:
  cmp [sqcounter],50
  jne setsq4
  mov [sqdir],1
 setsq4:
  cmp [sqdir],0
  jne setsq2
  dec [sqcounter]
  jmp SetSqEnd
 setsq2:
  inc [sqcounter]
  SetSqEnd:
ret
random:
  mov eax,[randseed]
  sub eax,43ab45b5h
  ror eax,1
  xor eax,32c4324fh
  ror eax,1
  mov [randseed],eax
ret
CalculateAngle:
  finit
  fld [oneDeg]
  fimul [degCounter]
  fsincos
;  fimul [i1024]
  fstp [sinbeta]
 ; fimul [i1024]
  fstp [cosbeta]
  cmp [degCounter],360
  jne goAng
  mov [degCounter],-1
  goAng:
  inc [degCounter]
ret
CopyLines:
  mov ecx,LinesCount*3+1
  cld
  mov esi,lines3d
  mov edi,RotatedLines3d
  rep movsd
ret
Rotate:                     ; xo , zo - constans
  finit
  mov ebx,RotatedLines3d
  doRotate:
  mov ax,word[ebx];x1
  sub ax,xo
  mov [xsub],ax
  mov ax,word[ebx+8];z1
  sub ax,zo
  mov [zsub],ax
  fld [sinbeta]
  fimul [zsub]
  fchs
  fld [cosbeta]
  fimul [xsub]
  faddp
  fistp word[ebx];x1
;  mov  ax,[zsub]
;  movsx eax,ax
;  imul [sinbeta]
;  mov ebx,eax
;  mov ax,[xsub]
;  movsx eax,ax
;  imul [cosbeta]
;  sub eax,ebx
;  shr eax,10
;  mov word[ebx],ax

  add word[ebx],xo
  fld [sinbeta]
  fimul [xsub]
  fld [cosbeta]
  fimul [zsub]
  faddp
  fistp word[ebx+8];z1
  add word[ebx+8],zo

  mov ax,word[ebx+2];x2
  sub ax,xo
  mov [xsub],ax
  mov ax,word[ebx+10];z2
  sub ax,zo
  mov [zsub],ax
  fld [sinbeta]
  fimul [zsub]
  fchs
  fld [cosbeta]
  fimul [xsub]
  faddp
  fistp word[ebx+2];x2
  add word[ebx+2],xo
  fld [sinbeta]
  fimul [xsub]
  fld [cosbeta]
  fimul [zsub]
  faddp
  fistp word[ebx+10];z2
  add word[ebx+10],zo

  add ebx,12
  cmp [ebx], dword 0xffffffff
  jne doRotate
ret

TranslateLines:
   finit
   mov ebx,RotatedLines3d
   mov edx,points
  Translate:
   fld [sq]
   fimul word[ebx+8]; [z1]
   fld st
   fiadd word[ebx]; [x1]
   fistp word[edx];[x1]
   fchs
   fiadd word[ebx+4];[y1]
   fistp word[edx++4];[y1]
   fld [sq]
   fimul word[ebx+10]; [z2]
   fld st
   fiadd word[ebx+2];[x2]
   fistp word[edx+2];[x2]
   fchs
   fiadd word[ebx+6];[y2]
   fistp word[edx+6];[y2]
   add ebx,12
   add edx,8
   cmp [ebx], dword 0xffffffff
   je endTranslate
   jmp Translate
   endTranslate:
   mov [edx], dword 0xffffffff
ret

DrawLines:
   mov ebx,points              ; draw lines
   next_line:
;    mov edx,[ebx]
;    mov ecx,[ebx+4]
;    push ebx
;    mov ebx,edx
;    mov edx,[col]
;    mov eax,38
;    int 0x40
;    pop ebx
    push ebx
    mov eax,[ebx]
    shr eax,16
    mov ecx,[ebx+4]
    shr ecx,16
    mov edx,[ebx+4]
    and edx,0x0000ffff
    push dword[ebx]
    pop ebx
    and ebx,0x0000ffff
    mov edi,screen_buffer
    call draw_line
    pop ebx
    add ebx,8
    cmp [ebx],dword 0xffffffff
    jne next_line
ret
include "lines.inc"
;   *********************************************
;   *******  WINDOW DEFINITIONS AND DRAW ********
;   *********************************************


draw_window:


    mov  eax,12                    ; function 12:tell os about windowdraw
    mov  ebx,1                     ; 1, start of draw
    int  0x40

                                   ; DRAW WINDOW
    mov  eax,0                     ; function 0 : define and draw window
    mov  ebx,50*65536+Wmaxx         ; [x start] *65536 + [x size]
    mov  ecx,20*65536+Wmaxy         ; [y start] *65536 + [y size]
    mov  edx,0x02000000            ; color of work area RRGGBB,8->color gl
    mov  esi,0x805080d0            ; color of grab bar  RRGGBB,8->color gl
    mov  edi,0x005080d0            ; color of frames    RRGGBB
    int  0x40

                                   ; WINDOW LABEL
    mov  eax,4                     ; function 4 : write text to window
    mov  ebx,8*65536+8             ; [x start] *65536 + [y start]
    mov  ecx,0x10ddeeff            ; font 1 & color ( 0xF0RRGGBB )
    mov  edx,labelt                ; pointer to text beginning
    mov  esi,labellen-labelt       ; text length
    int  0x40

                                   ; CLOSE BUTTON
    mov  eax,8                     ; function 8 : define and draw button
    mov  ebx,(Wmaxx-19)*65536+12    ; [x start] *65536 + [x size]
    mov  ecx,5*65536+12            ; [y start] *65536 + [y size]
    mov  edx,1                     ; button id
    mov  esi,0x6688dd              ; button color RRGGBB
    int  0x40

;    mov  ebx,20*65536+35           ; draw info text with function 4
;    mov  ecx,0x224466
;    mov  edx,text
;    mov  esi,40
;  newline:
;    mov  eax,4
;    int  0x40
;    add  ebx,10
;    add  edx,40
;    cmp  [edx],byte 'x'
;    jne  newline
;
    mov  eax,12                    ; function 12:tell os about windowdraw
    mov  ebx,2                     ; 2, end of draw
    int  0x40

    ret


; DATA AREA
i1024 dw 1024
randseed dd 0xabcdef22
xsub dw ?
zsub dw ?
degCounter dd 0
oneDeg  dd 0.017453
sinbeta dd ?
cosbeta dd ?
sinbetar dd ?
cosbetar dd ?
sqcounter dd 600
sq dd 0.707
onesq dd 0.001
sqdir dd 0
lines3d:
  dw 100        ; x start
  dw 100        ; x end
  dw 300        ; y start
  dw 300        ; y end
  dw 100        ; z start
  dw 200        ; z end
  dw 100,200,300,300,200,300, 200,300,300,300,300,300, 300,400,300,300,300,200
  dw 400,400,300,300,200,100, 400,300,300,300,100,0,   300,200,300,300,0,0
  dw 200,100,300,300,0,  100
  dw 250,210,300,300,-20,20,  210,125,300,300,20,20,   125,120,300,310,20,100
  dw 120,75, 310,288,100,150, 75,125,288,310,150,180,  125,130,310,290,180,270
  dw 130,205,290,315,270,275, 205,250,315,290,275,320, 250,295,290,310,320,275
  dw 295,375,310,290,275,270, 375,380,290,310,270,190, 380,420,310,290,190,150
  dw 420,375,290,310,150,100, 375,366,310,290,100,30,  366,300,290,310,30,20
  dw 300,250,310,300,20,-20
  dw 100        ; x start  Thorns
  dw  75        ; x end
  dw 300        ; y start
  dw 300        ; y end
  dw 100        ; z start
  dw 75        ; z end
  dw 100,75,300,300,200,225,  200,175,300,300,300,325, 300,325,300,300,300,325
  dw 400,425,300,300,200,225, 400,425,300,300,100,75,  300,325,300,300,0,-25
  dw 200,180,300,300,0,-25
  dw 250,250,300,300,-20,-50, 210,240,300,300,20,50,   125,110,300,310,20,10
  dw 120,150,310,288,100,110, 75,50,  288,310,150,150, 125,150,310,290,180,175
  dw 130,110,290,300,270,280, 205,225,315,300,275,255, 250,250,290,300,320,350
  dw 295,275,310,300,275,255, 375,390,290,300,270,280, 380,355,310,300,190,175
  dw 420,440,290,300,150,150, 375,360,310,290,100,125, 366,380,290,310,30,0
  dw 300,280,310,300,20,45
  dw 100        ; x start  Thorns1
  dw  75        ; x end
  dw 300        ; y start
  dw 275        ; y end
  dw 100        ; z start
  dw 75         ; z end
  dw 100,75,300,275,200,225,  200,175,300,275,300,325, 300,325,300,275,300,325
  dw 400,425,300,275,200,225, 400,425,300,275,100,75,  300,325,300,275,0,-25
  dw 200,180,300,275,0,-25
  dw 250,250,300,275,-20,-50, 210,240,300,275,20,50,   125,110,300,310,20,10
  dw 120,150,310,310,100,110, 75,50,  288,310,150,150, 125,150,310,290,180,175
  dw 130,110,290,275,270,280, 205,225,315,275,275,255, 250,250,290,300,320,350
  dw 295,275,310,275,275,255, 375,390,290,275,270,280, 380,355,310,300,190,17
  dw 420,440,290,275,150,150, 375,360,310,275,100,125, 366,380,290,310,30,0
  dw 300,280,310,275,20,45


  dd 0xffffffff        ; end marker
col dd 0x00ffffff
labelt:
     db   'THORNS CROWN OF JESUS CHRIST SAVE US !!!'
labellen:
points  rb 1000
RotatedLines3d rb 1000
ThornsList rb 1000
screen_buffer rb X_SIZE*Y_SIZE*3

I_END:




