;
;   author    : macgub
;   program   : drawing lines procedure
;   compiler  : FASM
;   sytem     : MenuetOS
;   Thanks to Piotr Tarsa for alghoritm
;TIMEOUT EQU 1
;X_SIZE equ 700
;Y_SIZE equ 500

draw_line:
;----------------DRAWING LINE PROCEDURE------------------------------
;in - eax    - [x_start]
;     ebx    - [x_end]
;     ecx    - [y_start]
;     edx    - [y_end]
;     edi    - memory pointer with screen buffer
;     [col]  - 'global' dd variable with color 0x00rrggbb
;     X_SIZE - constans with scrreen buffer width
;     Y_SIZE - constans with screen buffer height
  mov [lx1],eax
  mov [lx2],ebx
  mov [ly1],ecx
  mov [ly2],edx

  cmp eax,ebx
  je vertical_l
  cmp ecx,edx
  je horizontal_l
;  finit                 ; uncomment to calculate delta_x .._y on FPU
;  fild [lx1]
;  fisub [lx2]
;  fabs
;  fistp [delta_x]
;  fild [ly1]
;  fisub [ly2]
;  fabs
;  fistp [delta_y]
;  fnop
  push ecx
  sub eax,ebx
  cmp eax,0
  jg l_absx_no
  neg eax
 l_absx_no:
  mov [delta_x],eax
  sub ecx,edx
  cmp ecx,0
  jg l_absy_no
  neg ecx
 l_absy_no:
  mov [delta_y],ecx
  pop ecx
  mov eax,[delta_x]
  cmp eax,[delta_y]
  je deg45_l               ; line under 45 degrees
  jl more_vertical_l       ; slashed more vertical line
  jg more_horizon_l       ; slashed more horizontal_l
  jmp end_line

 horizontal_l:          ;-----------------------------------------
  cmp ebx,eax           ;------------horizontal line-------------
  jg hor1
  xchg eax,ebx
 hor1:
  push eax
  mov eax,X_SIZE*3
  mul [ly1]
  add edi,eax
  pop eax
  add edi,eax
  push eax
  shl eax,1
  add edi,eax
  pop eax
  mov edx,[col]
 hor2:
  or [edi],edx
  add edi,3
  cmp eax,ebx
  je end_line
  inc eax
  jmp hor2
 vertical_l:              ;-----------vertical line-------------------
  cmp edx,ecx             ;-------------------------------------------
  jg vert1
  xchg ecx,edx
 vert1:
  push edx
  mov eax,X_SIZE*3
  mul ecx
  add edi,eax
  pop edx
  add edi,ebx
  shl ebx,1
  add edi,ebx
  mov eax,[col]
 vert2:
  or [edi],eax
  add edi,X_SIZE*3
  cmp ecx,edx
  je end_line
  inc ecx
  jmp vert2

 deg45_l:                  ;----------line under 45 degrees-----
  mov eax,[lx1]            ;------------------------------------
  cmp ebx,eax
  jg deg45_1
  xchg ebx,eax
  xchg edx,ecx
 deg45_1:
  mov esi,eax
  push edx
  mov eax,X_SIZE*3
  mul ecx
  add edi,eax
  pop edx
  mov eax,esi
  add edi,eax
  shl eax,1
  add edi,eax
  mov eax,esi
  mov esi,[col]
 deg45_2:
  or [edi],esi
  cmp eax,ebx
  je end_line
  inc eax
  cmp edx,ecx
  jg deg45_dx_greater
  sub edi,X_SIZE*3-3
  jmp deg45_2
 deg45_dx_greater:
  add edi,X_SIZE*3+3
  jmp deg45_2

 more_vertical_l:    ;-----slashed more vertical line------------
  mov eax,[lx1]      ;-------------------------------------------
  cmp edx,ecx
  jg m_vert_2
  xchg eax,ebx
  xchg ecx,edx
  mov [lx1],eax
  mov [lx2],ebx
  mov [ly1],ecx
  mov [ly2],edx
 m_vert_2:
  cmp ebx,eax  ;-        ; set 'x' polarization (sign) flag
  jl m_vert_3  ;-
  mov edx,1    ;-
  jmp m_vert_4 ;-
 m_vert_3:     ;-
  xor edx,edx  ;-
 m_vert_4:     ;-
  mov esi,eax
  push edx             ; <--edx - 'x' polarization (sign) flag
  mov eax,X_SIZE*3
  mul ecx
  add edi,eax
  mov eax,esi
  add edi,eax
  shl eax,1
  add edi,eax
  mov eax,esi
  ;finit
  ;fild [lx2]      ; uncomment for calculates on FPU
  ;fisub [lx1]
  ;fild [ly2]
  ;fisub [ly1]
  ;fdivp
  ;fstp [delta]
  ;fldz
  mov eax,[delta_x] ;-
  shl eax,10        ;-
  div [delta_y]     ;-
  mov [idelta],eax  ;-
  xor eax,eax       ;-
  mov esi,[col]
  mov ecx,[delta_y]
  or [edi],esi
  pop edx
 m_vert_1:
  ;fadd [delta]    ; for calculates on FPU
  ;fld st
  ;fistp [help] ; <---- [help] current relative 'x' position
  add eax,[idelta] ;-
  push eax         ;-
  shr eax,10       ;-
  mov [help],eax   ;- ;<---[help]-current relative x position
  pop eax          ;-
  add edi,X_SIZE*3
  push edi
  cmp edx,1       ;-    ; check 'x'polarization
  je m_vert_5     ;-
  neg [help]      ;-
 m_vert_5:        ;-
  add edi,[help]
  shl [help],1
  add edi,[help]
  or [edi],esi
  pop edi
  loop m_vert_1
  ;ffree st0
  jmp end_line

 more_horizon_l:       ;-------slashed more horizontal line----------
  mov eax,[lx1]        ;-------------------------------------------
  cmp ebx,eax
  jg m_hor_noreverse
  xchg eax,ebx
  xchg ecx,edx
  mov [lx1],eax
  mov [lx2],ebx
  mov [ly1],ecx
  mov [ly2],edx
 m_hor_noreverse:
    ;cmp edx,ecx      ; I try with integer calculating
    ;jl m_hor_1       ; like in more vertical lines cause
    ;mov edx,1
    ;jmp m_hor_2
    ;m_hor_1:
    ;xor edx,edx
    ;m_hor_2:
    ;push edx
  mov esi,eax
  mov eax,X_SIZE*3
  mul ecx
  add edi,eax
  mov eax,esi
  add edi,eax
  shl eax,1
  add edi,eax
  mov eax,esi
  finit
  fild [ly2]
  fisub [ly1]
  fild [lx2]
  fisub [lx1]
  fdivp
  fstp [delta]
  fldz
    ;mov eax,[delta_y]
    ;shl eax,16
    ;div [delta_x]
    ;mov [idelta],eax
  mov esi,[col]
  mov ecx,[delta_x]
  or [edi],esi
    ;pop edx
    ;xor eax,eax
 m_hor_main:
  add edi,3
  push edi
  fadd [delta]
  fld st
  fistp [help]
  fnop
    ;add eax,[idelta]
    ;push eax
    ;mov [help],eax
  mov eax,X_SIZE*3
  mul [help]
    ;cmp edx,0
    ;jne m_hor_3
    ;neg eax
    ;m_hor_3:
  add edi,eax
  or [edi],esi
    ;pop eax
  pop edi
  loop m_hor_main
  ffree st0
;  jmp end_line
;.....

 end_line:
ret
;DATA AREA FOR PROCEDURE DRAW LINE
lx1 dd ?
lx2 dd ?
ly1 dd ?
ly2 dd ?
delta_x dd ?
delta_y dd ?
delta dd ? ;real
idelta dd ? ;int
help dd ? ;int    <---help variable




; DATA AREA
;col dd 0x0000ff00
;screen_buffer rb X_SIZE*Y_SIZE*3




